import eslintPluginAngular from "eslint-plugin-angular";

/**
 * @typedef {import("eslint").Linter.Config} Config
 */

/**
 * @param {Config} config
 * @returns {Config}
 */
function defineConfig(config) {
	return config;
}

const severity = {
	0: "off",
	1: "warn",
	2: "error",
};

function migrate(config) {
	for (const [rule, options] of Object.entries(config.rules)) {
		if (typeof options === "number") {
			config.rules[rule] = severity[options];
		}
	}
	return config;
}

const johnpapa = migrate(eslintPluginAngular.configs.johnpapa);
const bestpractices = migrate(eslintPluginAngular.configs.bestpractices);

export default defineConfig({
	plugins: {
		angular: eslintPluginAngular,
	},

	rules: {
		...johnpapa.rules,
		...bestpractices.rules,
		"angular/controller-as-vm": ["error", "$ctrl"],
		"angular/file-name": "off",
		"angular/no-service-method": "off",
	},
});
